#include "ball.h"

Ball::Ball(Vector cen, float rad, Color c)
: sphere(cen, rad, c),
	velocity(0,0,0),
	rotVector(1,0,0),
	angSpeed(0)
{
	// Initialize the stored rotation matrix
	glLoadIdentity();
	glGetFloatv(GL_MODELVIEW_MATRIX, currentRotation);
}

Ball::~Ball(void)
{
}

// Set the vector to rotate around when rolling, and the linear rolling speed of the ball.
void Ball::setRollingRotation(Vector _rotVector, float speed)
{
	rotVector = _rotVector;
	angSpeed = speed / (sphere.getRadius() * 2*3.14159) * 360.0;
}

// Advance the rolling rotation of the ball by timestep time units
void Ball::advanceRollingRotation(float timestep)
{
	glLoadIdentity();
	glRotatef(-angSpeed*timestep, rotVector.x, rotVector.y, rotVector.z);  
	glMultMatrixf(currentRotation);
	glGetFloatv(GL_MODELVIEW_MATRIX, currentRotation);
}
