#pragma once
#include "Sphere.h"

class Ball
{
public:
	Ball(Vector cen, float rad, Color c);
	~Ball(void);

	void draw() const { sphere.drawRotated(currentRotation); }

	Vector getPosition() const { return sphere.getCenter(); }
	void setPosition(Vector newPosition) { sphere.setCenter(newPosition); }
	float getRadius() const { return sphere.getRadius(); }
	Vector getVelocity() const { return velocity; }
	void setVelocity(Vector newVelocity) { velocity = newVelocity; }
	void advanceRollingRotation(float timestep);
	void setRollingRotation(Vector _rotVector, float speed); // rotVector is vector to rotate around, speed is linear rolling speed
private:
	Sphere sphere;
	float currentRotation[16];  // rotation matrix for current rotation
	Vector velocity;
	// units of velocity are "GL world units / timestep"
	Vector rotVector; // rolling rotation vector
	float angSpeed;   // angular speed in degrees/timestep
};
