#pragma once

#include "includes.h"
#include <GL/glut.h>

class Hole
{
public:
	Hole(const Vector& location_, float radius_);
	~Hole(void);

	void draw() const;

	// Is the given point "in" the hole (since the hole is 2d, this is true if the point is
	// in the hole's plane (to within a tolerance) and within the circle the hole forms in that plane
	bool isIn(const Vector& point) const;

private:
	// tolerance to use when determining if a point is in the hole's plane:
	static const float TOLERANCE;

	// location of the center
	Vector location;
	// radius hole extends from the center (parallel to the x-z plane)
	float radius;
};
