#pragma once
#include "includes.h"

class Shape
{
public:
	// set color in the constructor; setting up bounding sphere might take more calculation,
	// so let the inherited class set that up itself rather than forcing it to pass it as a
	// constructor parameter
	Shape(Color c);
	~Shape(void);
	virtual void draw() const = 0;

	Vector getBoundingSphereCenter() const { return boundingSphereCenter; }
	float getBoundingSphereRadius() const { return boundingSphereRadius; }

protected:
	Color color;
	Vector boundingSphereCenter;
	float boundingSphereRadius;
};
