#pragma once

#include "shape.h"
#include "includes.h"
#include <GL/glut.h>

class Triangle :
	public Shape
{
public:
	Triangle(void);
	Triangle(const Vector& w1, const Vector& w2, const Vector& w3, const Color& c);
	~Triangle(void);
	virtual void draw() const;

	Vector getV1() const { return v1; }
	Vector getV2() const { return v2; }
	Vector getV3() const { return v3; }

	// Apply the triangle's forward or reverse transforms to a given point
	Vector forwardTransform(Vector point) const
		{ return transformPt(fwdTransform, point); }
	Vector reverseTransform(Vector point) const
		{ return transformPt(revTransform, point); }

private:
	Vector v1, v2, v3;

	// transformation matrices (4x4 matrices encoded in column-major form within a 1-dimensional
	// 16-element array, since that's the format GL uses)
	float fwdTransform[16];
	float revTransform[16];
};
