// camera.h - definition of camera class
#pragma once

#include "includes.h"

class Camera
{
public: 
	Camera();
	~Camera();

	// Set the focal point
	void lookAt(Vector p);
	// Set the position of the camera relative to the focal point in spherical coordinates (degrees)
	void setPosition(float newR, float newTheta, float newPhi);
	// Set the position of the camera relative to its current position
	void setRelativePosition(float dR, float dTheta, float dPhi);
	// Do the OpenGL tranform calls to set up the camera viewpoint
	void doTransform() const; 
	// theta accessor
	float getTheta() const { return theta; };
private:

	float r, theta, phi;
	Vector focalPoint;
};