//SEE CHANGE LOG UNDER RESOURCE FILES
#include <iostream>
#include <GL/glut.h>
#include "camera.h" 

// our includes
#include "World.h"
#include "Triangle.h"
#include "Ball.h"

using namespace std;


bool moving = false;

// function prototypes
void display(void);
void reshape(int width, int height);
void init(void); 

int main(int argc, char **argv)
{

  // set up window
  glutInitWindowSize(400, 400);
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
  glutCreateWindow("Untitled #2 g0lf");

  // register callback functions
  glutDisplayFunc(display);
  glutReshapeFunc(reshape);

  // initalize opengl parameters
  init();

  // Load in file if specified on command line, otherwise load default file "input.txt"
  if(argc > 1)
	  World::instance()->loadFile(argv[1]);
  else
	  World::instance()->loadFile("hollywood.txt");

  // loop until something happens
  glutMainLoop();
  return 0;           
}
void init()
{
  // initialize viewing system
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(45.0, 1.0, 0.1, 500.0); 
  glMatrixMode(GL_MODELVIEW);

  // initialize background color to black
  glClearColor(0.0,0.0,0.0,0.0);
 
  // enable depth buffering
  glEnable(GL_DEPTH_TEST);
}



void reshape(int width, int height)
{

  glViewport(0,0,width,height);
}

void display()
{
	// Draw everything in the world
	World::instance()->draw();
}
